/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* "%code top" blocks.  */
#line 1 "src/parse.y"

/*
 *  Parser for C declarations.
 *  Copyright © 2011-2012, 2021 Nick Bowler
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#line 88 "src/parse.c"

/* Substitute the variable and function names.  */
#define yyparse         cdecl__yyparse
#define yylex           cdecl__yylex
#define yyerror         cdecl__yyerror
#define yydebug         cdecl__yydebug
#define yynerrs         cdecl__yynerrs

/* First part of user prologue.  */
#line 29 "src/parse.y"

#include <config.h>
#include <assert.h>
#include <stdbool.h>

#include "scan.h"
#include "cdecl.h"
#include "cdecl-internal.h"

#define FAIL(msg) do { \
	yyerror(&yylloc, NULL, NULL, msg); \
	YYERROR; \
} while (0)

#define ALLOC(ptr, size) do { \
	(ptr) = malloc(size); \
	if (!(ptr)) { \
		cdecl__err(CDECL_ENOMEM); \
		YYERROR; \
	} \
} while (0)

#define ALLOC_STRUCT(ptr, type, ...) do { \
	ALLOC(ptr, sizeof (type)); \
	*(ptr) = (type) { __VA_ARGS__ }; \
} while (0)

#line 126 "src/parse.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "parse.h"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_T_LEX_ERROR = 3,                /* T_LEX_ERROR  */
  YYSYMBOL_T_ENGLISH = 4,                  /* T_ENGLISH  */
  YYSYMBOL_T_IDENT = 5,                    /* "identifier"  */
  YYSYMBOL_T_UINT = 6,                     /* "integer constant"  */
  YYSYMBOL_T_SEMICOLON = 7,                /* ";"  */
  YYSYMBOL_T_ASTERISK = 8,                 /* "*"  */
  YYSYMBOL_T_LPAREN = 9,                   /* "("  */
  YYSYMBOL_T_RPAREN = 10,                  /* ")"  */
  YYSYMBOL_T_LBRACKET = 11,                /* "["  */
  YYSYMBOL_T_RBRACKET = 12,                /* "]"  */
  YYSYMBOL_T_COMMA = 13,                   /* ","  */
  YYSYMBOL_T_ELLIPSIS = 14,                /* "..."  */
  YYSYMBOL_T_TYPEDEF = 15,                 /* "typedef"  */
  YYSYMBOL_T_EXTERN = 16,                  /* "extern"  */
  YYSYMBOL_T_STATIC = 17,                  /* "static"  */
  YYSYMBOL_T_AUTO = 18,                    /* "auto"  */
  YYSYMBOL_T_REGISTER = 19,                /* "register"  */
  YYSYMBOL_T_INLINE = 20,                  /* "inline"  */
  YYSYMBOL_T_RESTRICT = 21,                /* "restrict"  */
  YYSYMBOL_T_VOLATILE = 22,                /* "volatile"  */
  YYSYMBOL_T_CONST = 23,                   /* "const"  */
  YYSYMBOL_T_VOID = 24,                    /* "void"  */
  YYSYMBOL_T_CHAR = 25,                    /* "char"  */
  YYSYMBOL_T_SHORT = 26,                   /* "short"  */
  YYSYMBOL_T_INT = 27,                     /* "int"  */
  YYSYMBOL_T_LONG = 28,                    /* "long"  */
  YYSYMBOL_T_FLOAT = 29,                   /* "float"  */
  YYSYMBOL_T_DOUBLE = 30,                  /* "double"  */
  YYSYMBOL_T_SIGNED = 31,                  /* "signed"  */
  YYSYMBOL_T_UNSIGNED = 32,                /* "unsigned"  */
  YYSYMBOL_T_BOOL = 33,                    /* "_Bool"  */
  YYSYMBOL_T_COMPLEX = 34,                 /* "_Complex"  */
  YYSYMBOL_T_IMAGINARY = 35,               /* "_Imaginary"  */
  YYSYMBOL_T_STRUCT = 36,                  /* "struct"  */
  YYSYMBOL_T_UNION = 37,                   /* "union"  */
  YYSYMBOL_T_ENUM = 38,                    /* "enum"  */
  YYSYMBOL_T_TYPE = 39,                    /* "type"  */
  YYSYMBOL_T_DECLARE = 40,                 /* "declare"  */
  YYSYMBOL_T_POINTER = 41,                 /* "pointer"  */
  YYSYMBOL_T_FUNCTION = 42,                /* "function"  */
  YYSYMBOL_T_RETURNING = 43,               /* "returning"  */
  YYSYMBOL_T_ARRAY = 44,                   /* "array"  */
  YYSYMBOL_T_TO = 45,                      /* "to"  */
  YYSYMBOL_T_OF = 46,                      /* "of"  */
  YYSYMBOL_T_AS = 47,                      /* "as"  */
  YYSYMBOL_T_VLA = 48,                     /* "variable-length"  */
  YYSYMBOL_YYACCEPT = 49,                  /* $accept  */
  YYSYMBOL_input = 50,                     /* input  */
  YYSYMBOL_semi = 51,                      /* semi  */
  YYSYMBOL_declaration = 52,               /* declaration  */
  YYSYMBOL_declspecs = 53,                 /* declspecs  */
  YYSYMBOL_declspecs_noid = 54,            /* declspecs_noid  */
  YYSYMBOL_qualifiers = 55,                /* qualifiers  */
  YYSYMBOL_declarators = 56,               /* declarators  */
  YYSYMBOL_declarator_wrap = 57,           /* declarator_wrap  */
  YYSYMBOL_declspec_simple = 58,           /* declspec_simple  */
  YYSYMBOL_typespec_simple = 59,           /* typespec_simple  */
  YYSYMBOL_qualifier_simple = 60,          /* qualifier_simple  */
  YYSYMBOL_declspec_notype = 61,           /* declspec_notype  */
  YYSYMBOL_typespec_noid = 62,             /* typespec_noid  */
  YYSYMBOL_qualifier = 63,                 /* qualifier  */
  YYSYMBOL_typespec = 64,                  /* typespec  */
  YYSYMBOL_declspec_noid = 65,             /* declspec_noid  */
  YYSYMBOL_vla_ident = 66,                 /* vla_ident  */
  YYSYMBOL_array = 67,                     /* array  */
  YYSYMBOL_parameter = 68,                 /* parameter  */
  YYSYMBOL_parameters = 69,                /* parameters  */
  YYSYMBOL_varargs = 70,                   /* varargs  */
  YYSYMBOL_parameter_type_list = 71,       /* parameter_type_list  */
  YYSYMBOL_parens = 72,                    /* parens  */
  YYSYMBOL_pointer = 73,                   /* pointer  */
  YYSYMBOL_declarator = 74,                /* declarator  */
  YYSYMBOL_declarator_ish = 75,            /* declarator_ish  */
  YYSYMBOL_postfix = 76,                   /* postfix  */
  YYSYMBOL_direct_declarator_ish = 77,     /* direct_declarator_ish  */
  YYSYMBOL_direct_declarator = 78,         /* direct_declarator  */
  YYSYMBOL_english = 79,                   /* english  */
  YYSYMBOL_storage_func_specs = 80,        /* storage_func_specs  */
  YYSYMBOL_type_qual_spec = 81,            /* type_qual_spec  */
  YYSYMBOL_type_qual_specs = 82,           /* type_qual_specs  */
  YYSYMBOL_post_specs = 83,                /* post_specs  */
  YYSYMBOL_english_declaration = 84,       /* english_declaration  */
  YYSYMBOL_english_declarator = 85,        /* english_declarator  */
  YYSYMBOL_english_function = 86,          /* english_function  */
  YYSYMBOL_english_parameter_list = 87,    /* english_parameter_list  */
  YYSYMBOL_english_parameters = 88,        /* english_parameters  */
  YYSYMBOL_typedef_name_qual = 89,         /* typedef_name_qual  */
  YYSYMBOL_null_decl = 90,                 /* null_decl  */
  YYSYMBOL_english_parameter = 91,         /* english_parameter  */
  YYSYMBOL_english_array = 92,             /* english_array  */
  YYSYMBOL_english_vla = 93                /* english_vla  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;


/* Second part of user prologue.  */
#line 76 "src/parse.y"

static void free_decl(struct cdecl *);

static void free_declspec(struct cdecl_declspec *x)
{
	struct cdecl_declspec *p;
	while (x) {
		p = x->next;
		free(x->ident);
		free(x);
		x = p;
	}
}

static void free_declarator(struct cdecl_declarator *x)
{
	struct cdecl_declarator *p;

	while (x) {
		p = x->child;

		switch (x->type) {
		case CDECL_DECL_NULL:
			break;
		case CDECL_DECL_IDENT:
			free(x->u.ident);
			break;
		case CDECL_DECL_POINTER:
			free_declspec(x->u.pointer.qualifiers);
			break;
		case CDECL_DECL_ARRAY:
			free(x->u.array.vla);
			break;
		case CDECL_DECL_FUNCTION:
			free_decl(x->u.function.parameters);
			break;
		default:
			assert(0);
		}

		free(x);
		x = p;
	}
}

static void free_decl(struct cdecl *x)
{
	struct cdecl *p;

	while (x) {
		p = x->next;

		/* The specifiers may be shared by an entire chain. */
		if (!p || p->specifiers != x->specifiers)
			free_declspec(x->specifiers);

		free_declarator(x->declarators);
		free(x);
		x = p;
	}
}

void cdecl__free(struct cdecl *decl)
{
	free_decl(decl);
}

static void
yyerror(YYLTYPE *loc, yyscan_t scanner, struct cdecl **out, const char *err)
{
	if (strstr(err, "T_LEX_ERROR"))
		return;

	cdecl__err(CDECL_ENOPARSE, "%s", err);
}

#line 330 "src/parse.c"


#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_uint8 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if 1

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* 1 */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE) \
             + YYSIZEOF (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  43
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   285

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  49
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  45
/* YYNRULES -- Number of rules.  */
#define YYNRULES  102
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  139

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   303


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   244,   244,   246,   250,   250,   252,   259,   262,   267,
     267,   272,   272,   277,   277,   282,   286,   287,   288,   289,
     290,   291,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   306,   307,   308,   310,   310,   314,
     318,   322,   322,   326,   330,   334,   340,   340,   342,   342,
     347,   354,   358,   363,   369,   369,   374,   374,   376,   391,
     393,   400,   405,   412,   412,   413,   413,   414,   414,   416,
     419,   424,   427,   431,   436,   444,   448,   448,   454,   454,
     456,   456,   466,   477,   490,   493,   498,   501,   506,   510,
     514,   529,   532,   534,   541,   556,   556,   560,   570,   574,
     581,   587,   587
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if 1
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "T_LEX_ERROR",
  "T_ENGLISH", "\"identifier\"", "\"integer constant\"", "\";\"", "\"*\"",
  "\"(\"", "\")\"", "\"[\"", "\"]\"", "\",\"", "\"...\"", "\"typedef\"",
  "\"extern\"", "\"static\"", "\"auto\"", "\"register\"", "\"inline\"",
  "\"restrict\"", "\"volatile\"", "\"const\"", "\"void\"", "\"char\"",
  "\"short\"", "\"int\"", "\"long\"", "\"float\"", "\"double\"",
  "\"signed\"", "\"unsigned\"", "\"_Bool\"", "\"_Complex\"",
  "\"_Imaginary\"", "\"struct\"", "\"union\"", "\"enum\"", "\"type\"",
  "\"declare\"", "\"pointer\"", "\"function\"", "\"returning\"",
  "\"array\"", "\"to\"", "\"of\"", "\"as\"", "\"variable-length\"",
  "$accept", "input", "semi", "declaration", "declspecs", "declspecs_noid",
  "qualifiers", "declarators", "declarator_wrap", "declspec_simple",
  "typespec_simple", "qualifier_simple", "declspec_notype",
  "typespec_noid", "qualifier", "typespec", "declspec_noid", "vla_ident",
  "array", "parameter", "parameters", "varargs", "parameter_type_list",
  "parens", "pointer", "declarator", "declarator_ish", "postfix",
  "direct_declarator_ish", "direct_declarator", "english",
  "storage_func_specs", "type_qual_spec", "type_qual_specs", "post_specs",
  "english_declaration", "english_declarator", "english_function",
  "english_parameter_list", "english_parameters", "typedef_name_qual",
  "null_decl", "english_parameter", "english_array", "english_vla", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-70)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-1)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     109,    -8,   -70,   -70,   -70,   -70,   -70,   -70,   -70,   -70,
     -70,   -70,   -70,   -70,   -70,   -70,   -70,   -70,   -70,   -70,
     -70,   -70,   -70,   -70,    13,    29,    34,    46,   -70,    25,
     -70,   -70,   -70,   211,   -70,   -70,   235,    42,    37,   -70,
     -70,   -70,   -70,   -70,   -70,   -70,    36,     0,   -70,   -70,
      14,   -70,   -70,   -70,   -70,   235,    42,   -70,   -70,     7,
       6,   -70,   -70,    25,   143,     4,   -70,   -70,   -70,   -70,
     -70,   -27,    42,   -70,   -70,    14,   -70,    25,   -70,    50,
      45,   -70,    57,    14,   -70,    60,   -70,   -70,    61,    -3,
      -2,    31,    74,   -70,   -70,   -70,   -70,   -70,   177,   -70,
     -70,   -70,   -70,   -70,   -70,    65,   -70,    23,   -70,    71,
      32,   250,   -70,   -70,    39,   -70,    77,    75,   -70,   -70,
     -70,   -70,    44,   -70,   -70,   -70,   250,   -70,    42,    43,
      73,    33,   -70,   -70,   -70,   -70,   -70,   -70,   -70
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int8 yydefact[] =
{
       0,     0,    45,    17,    18,    19,    16,    20,    21,    35,
      36,    34,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,     0,     0,     0,     0,     3,    71,
      38,    39,    40,     0,    41,    37,     9,    76,     0,     2,
      42,    43,    44,     1,    72,    11,     4,    13,    64,    15,
      63,     7,     8,    46,    47,     9,    76,    84,    75,     0,
      71,     5,     6,    71,    69,     0,    67,    68,    73,    10,
      77,    11,    76,    12,    62,    61,    14,    71,    54,    56,
       0,    66,     0,    65,    48,     0,    49,    52,     0,     0,
       0,     0,     0,    83,    87,    86,    74,    53,     0,    58,
      59,    60,    70,    50,    51,    76,    88,     0,   100,   102,
       0,    80,    57,    55,    11,    95,     0,    56,    94,    92,
      99,   101,     0,    85,    78,    79,    80,    82,    76,    93,
       0,    76,    90,    96,    98,    81,    97,    89,    91
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -70,   -70,   -70,   -70,     8,    62,   -69,    26,   -70,   -37,
     -70,   -70,   -29,   -33,   -55,    27,   -70,   -70,   -70,    20,
     -70,     3,   -70,   -70,   -40,    72,   -70,    38,   -70,    63,
     -70,    66,   -70,    24,   -70,   -36,   -70,   -70,   -70,   -70,
     -70,   -70,    21,   -70,   -70
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_uint8 yydefgoto[] =
{
       0,    27,    62,    28,    77,    52,    60,    46,    47,    30,
      31,    32,    33,    34,    35,    36,    55,    88,    66,    78,
      79,    99,    80,    67,    48,    49,    82,    68,    83,    50,
      39,    57,   126,   127,    93,   115,    71,    94,   116,   117,
     118,   133,   119,    95,   122
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_uint8 yytable[] =
{
      56,    58,    92,    54,   107,    73,   105,    53,    29,    84,
      85,    44,    86,    63,    45,    89,    87,    90,    40,    56,
      74,    91,    54,    64,    81,    65,    53,     9,    10,    11,
      44,    37,    38,    45,    41,    56,    96,    73,   114,    42,
     106,    51,    59,    61,   108,   129,    43,   112,     3,     4,
       5,     6,     7,     8,    72,   100,   125,     3,     4,     5,
       6,     7,     8,    98,     9,    10,    11,   101,    56,   120,
     114,   125,   103,   104,    73,   109,   121,   123,   124,     2,
       3,     4,     5,     6,     7,     8,   128,   130,   131,    76,
     134,    56,   136,   124,    56,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,     1,     2,   110,   137,    69,   113,   111,
     132,   102,    70,    75,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,     2,    97,
     135,    45,   138,     0,     0,     0,     0,     0,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,     2,     0,     0,     0,     0,     0,     0,     0,
       0,   112,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,     2,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23
};

static const yytype_int16 yycheck[] =
{
      37,    37,    71,    36,     6,    60,     9,    36,     0,     5,
       6,     5,     8,    13,     8,    42,    12,    44,     5,    56,
      60,    48,    55,     9,    64,    11,    55,    21,    22,    23,
       5,    39,    40,     8,     5,    72,    72,    92,     5,     5,
      43,    33,     5,     7,    46,   114,     0,    14,    15,    16,
      17,    18,    19,    20,    47,    10,   111,    15,    16,    17,
      18,    19,    20,    13,    21,    22,    23,    10,   105,    46,
       5,   126,    12,    12,   129,    44,     5,    45,   111,     5,
      15,    16,    17,    18,    19,    20,    47,    10,    13,    63,
      46,   128,   128,   126,   131,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,     4,     5,    41,    43,    55,    98,    92,
     117,    83,    56,    60,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,     5,    77,
     126,     8,   131,    -1,    -1,    -1,    -1,    -1,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,     5,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,     5,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int8 yystos[] =
{
       0,     4,     5,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    50,    52,    53,
      58,    59,    60,    61,    62,    63,    64,    39,    40,    79,
       5,     5,     5,     0,     5,     8,    56,    57,    73,    74,
      78,    53,    54,    61,    62,    65,    58,    80,    84,     5,
      55,     7,    51,    13,     9,    11,    67,    72,    76,    54,
      80,    85,    47,    63,    73,    78,    56,    53,    68,    69,
      71,    73,    75,    77,     5,     6,     8,    12,    66,    42,
      44,    48,    55,    83,    86,    92,    84,    74,    13,    70,
      10,    10,    76,    12,    12,     9,    43,     6,    46,    44,
      41,    64,    14,    68,     5,    84,    87,    88,    89,    91,
      46,     5,    93,    45,    62,    63,    81,    82,    47,    55,
      10,    13,    70,    90,    46,    82,    84,    43,    91
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr1[] =
{
       0,    49,    50,    50,    51,    51,    52,    53,    53,    54,
      54,    55,    55,    56,    56,    57,    58,    58,    58,    58,
      58,    58,    59,    59,    59,    59,    59,    59,    59,    59,
      59,    59,    59,    59,    60,    60,    60,    61,    61,    62,
      63,    64,    64,    64,    64,    64,    65,    65,    66,    66,
      67,    67,    67,    68,    69,    69,    70,    70,    71,    72,
      72,    73,    73,    74,    74,    75,    75,    76,    76,    77,
      77,    78,    78,    78,    79,    79,    80,    80,    81,    81,
      82,    82,    83,    84,    85,    85,    85,    85,    86,    86,
      87,    88,    88,    89,    90,    91,    91,    91,    92,    92,
      92,    93,    93
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     2,     1,     0,     1,     3,     2,     2,     0,
       2,     0,     2,     1,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     2,     2,     1,     1,     1,     1,     1,
       3,     3,     2,     2,     1,     3,     0,     2,     2,     3,
       3,     3,     3,     1,     1,     1,     1,     1,     1,     0,
       2,     0,     1,     2,     4,     2,     0,     2,     1,     1,
       0,     2,     3,     3,     0,     4,     2,     2,     2,     5,
       2,     3,     1,     2,     0,     1,     2,     3,     4,     3,
       2,     1,     0
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (&yylloc, scanner, out, YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF

/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YYLOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

# ifndef YYLOCATION_PRINT

#  if defined YY_LOCATION_PRINT

   /* Temporary convenience wrapper in case some people defined the
      undocumented and private YY_LOCATION_PRINT macros.  */
#   define YYLOCATION_PRINT(File, Loc)  YY_LOCATION_PRINT(File, *(Loc))

#  elif defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static int
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  int res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
}

#   define YYLOCATION_PRINT  yy_location_print_

    /* Temporary convenience wrapper in case some people defined the
       undocumented and private YY_LOCATION_PRINT macros.  */
#   define YY_LOCATION_PRINT(File, Loc)  YYLOCATION_PRINT(File, &(Loc))

#  else

#   define YYLOCATION_PRINT(File, Loc) ((void) 0)
    /* Temporary convenience wrapper in case some people defined the
       undocumented and private YY_LOCATION_PRINT macros.  */
#   define YY_LOCATION_PRINT  YYLOCATION_PRINT

#  endif
# endif /* !defined YYLOCATION_PRINT */


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, Location, scanner, out); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, void *scanner, struct cdecl **out)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  YY_USE (yylocationp);
  YY_USE (scanner);
  YY_USE (out);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, void *scanner, struct cdecl **out)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  YYLOCATION_PRINT (yyo, yylocationp);
  YYFPRINTF (yyo, ": ");
  yy_symbol_value_print (yyo, yykind, yyvaluep, yylocationp, scanner, out);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp,
                 int yyrule, void *scanner, struct cdecl **out)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)],
                       &(yylsp[(yyi + 1) - (yynrhs)]), scanner, out);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule, scanner, out); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


/* Context of a parse error.  */
typedef struct
{
  yy_state_t *yyssp;
  yysymbol_kind_t yytoken;
  YYLTYPE *yylloc;
} yypcontext_t;

/* Put in YYARG at most YYARGN of the expected tokens given the
   current YYCTX, and return the number of tokens stored in YYARG.  If
   YYARG is null, return the number of expected tokens (guaranteed to
   be less than YYNTOKENS).  Return YYENOMEM on memory exhaustion.
   Return 0 if there are more than YYARGN expected tokens, yet fill
   YYARG up to YYARGN. */
static int
yypcontext_expected_tokens (const yypcontext_t *yyctx,
                            yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  int yyn = yypact[+*yyctx->yyssp];
  if (!yypact_value_is_default (yyn))
    {
      /* Start YYX at -YYN if negative to avoid negative indexes in
         YYCHECK.  In other words, skip the first -YYN actions for
         this state because they are default actions.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;
      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yyx;
      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
        if (yycheck[yyx + yyn] == yyx && yyx != YYSYMBOL_YYerror
            && !yytable_value_is_error (yytable[yyx + yyn]))
          {
            if (!yyarg)
              ++yycount;
            else if (yycount == yyargn)
              return 0;
            else
              yyarg[yycount++] = YY_CAST (yysymbol_kind_t, yyx);
          }
    }
  if (yyarg && yycount == 0 && 0 < yyargn)
    yyarg[0] = YYSYMBOL_YYEMPTY;
  return yycount;
}




#ifndef yystrlen
# if defined __GLIBC__ && defined _STRING_H
#  define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
# else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
# endif
#endif

#ifndef yystpcpy
# if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#  define yystpcpy stpcpy
# else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
# endif
#endif

#ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYPTRDIFF_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYPTRDIFF_T yyn = 0;
      char const *yyp = yystr;
      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (yyres)
    return yystpcpy (yyres, yystr) - yyres;
  else
    return yystrlen (yystr);
}
#endif


static int
yy_syntax_error_arguments (const yypcontext_t *yyctx,
                           yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yyctx->yytoken != YYSYMBOL_YYEMPTY)
    {
      int yyn;
      if (yyarg)
        yyarg[yycount] = yyctx->yytoken;
      ++yycount;
      yyn = yypcontext_expected_tokens (yyctx,
                                        yyarg ? yyarg + 1 : yyarg, yyargn - 1);
      if (yyn == YYENOMEM)
        return YYENOMEM;
      else
        yycount += yyn;
    }
  return yycount;
}

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return -1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return YYENOMEM if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                const yypcontext_t *yyctx)
{
  enum { YYARGS_MAX = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  yysymbol_kind_t yyarg[YYARGS_MAX];
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* Actual size of YYARG. */
  int yycount = yy_syntax_error_arguments (yyctx, yyarg, YYARGS_MAX);
  if (yycount == YYENOMEM)
    return YYENOMEM;

  switch (yycount)
    {
#define YYCASE_(N, S)                       \
      case N:                               \
        yyformat = S;                       \
        break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
    }

  /* Compute error message size.  Don't count the "%s"s, but reserve
     room for the terminator.  */
  yysize = yystrlen (yyformat) - 2 * yycount + 1;
  {
    int yyi;
    for (yyi = 0; yyi < yycount; ++yyi)
      {
        YYPTRDIFF_T yysize1
          = yysize + yytnamerr (YY_NULLPTR, yytname[yyarg[yyi]]);
        if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
          yysize = yysize1;
        else
          return YYENOMEM;
      }
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return -1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yytname[yyarg[yyi++]]);
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, YYLTYPE *yylocationp, void *scanner, struct cdecl **out)
{
  YY_USE (yyvaluep);
  YY_USE (yylocationp);
  YY_USE (scanner);
  YY_USE (out);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  switch (yykind)
    {
    case YYSYMBOL_T_IDENT: /* "identifier"  */
#line 153 "src/parse.y"
            { free(((*yyvaluep).strval)); }
#line 1531 "src/parse.c"
        break;

    case YYSYMBOL_declaration: /* declaration  */
#line 156 "src/parse.y"
            { free_decl(((*yyvaluep).decl)); }
#line 1537 "src/parse.c"
        break;

    case YYSYMBOL_declspecs: /* declspecs  */
#line 154 "src/parse.y"
            { free_declspec(((*yyvaluep).declspec)); }
#line 1543 "src/parse.c"
        break;

    case YYSYMBOL_declspecs_noid: /* declspecs_noid  */
#line 154 "src/parse.y"
            { free_declspec(((*yyvaluep).declspec)); }
#line 1549 "src/parse.c"
        break;

    case YYSYMBOL_qualifiers: /* qualifiers  */
#line 154 "src/parse.y"
            { free_declspec(((*yyvaluep).declspec)); }
#line 1555 "src/parse.c"
        break;

    case YYSYMBOL_declarators: /* declarators  */
#line 156 "src/parse.y"
            { free_decl(((*yyvaluep).decl)); }
#line 1561 "src/parse.c"
        break;

    case YYSYMBOL_declarator_wrap: /* declarator_wrap  */
#line 156 "src/parse.y"
            { free_decl(((*yyvaluep).decl)); }
#line 1567 "src/parse.c"
        break;

    case YYSYMBOL_declspec_notype: /* declspec_notype  */
#line 154 "src/parse.y"
            { free_declspec(((*yyvaluep).declspec)); }
#line 1573 "src/parse.c"
        break;

    case YYSYMBOL_typespec_noid: /* typespec_noid  */
#line 154 "src/parse.y"
            { free_declspec(((*yyvaluep).declspec)); }
#line 1579 "src/parse.c"
        break;

    case YYSYMBOL_qualifier: /* qualifier  */
#line 154 "src/parse.y"
            { free_declspec(((*yyvaluep).declspec)); }
#line 1585 "src/parse.c"
        break;

    case YYSYMBOL_typespec: /* typespec  */
#line 154 "src/parse.y"
            { free_declspec(((*yyvaluep).declspec)); }
#line 1591 "src/parse.c"
        break;

    case YYSYMBOL_declspec_noid: /* declspec_noid  */
#line 154 "src/parse.y"
            { free_declspec(((*yyvaluep).declspec)); }
#line 1597 "src/parse.c"
        break;

    case YYSYMBOL_vla_ident: /* vla_ident  */
#line 153 "src/parse.y"
            { free(((*yyvaluep).strval)); }
#line 1603 "src/parse.c"
        break;

    case YYSYMBOL_array: /* array  */
#line 155 "src/parse.y"
            { free_declarator(((*yyvaluep).declarator)); }
#line 1609 "src/parse.c"
        break;

    case YYSYMBOL_parameter: /* parameter  */
#line 156 "src/parse.y"
            { free_decl(((*yyvaluep).decl)); }
#line 1615 "src/parse.c"
        break;

    case YYSYMBOL_parameters: /* parameters  */
#line 156 "src/parse.y"
            { free_decl(((*yyvaluep).decl)); }
#line 1621 "src/parse.c"
        break;

    case YYSYMBOL_parameter_type_list: /* parameter_type_list  */
#line 155 "src/parse.y"
            { free_declarator(((*yyvaluep).declarator)); }
#line 1627 "src/parse.c"
        break;

    case YYSYMBOL_parens: /* parens  */
#line 155 "src/parse.y"
            { free_declarator(((*yyvaluep).declarator)); }
#line 1633 "src/parse.c"
        break;

    case YYSYMBOL_pointer: /* pointer  */
#line 155 "src/parse.y"
            { free_declarator(((*yyvaluep).declarator)); }
#line 1639 "src/parse.c"
        break;

    case YYSYMBOL_declarator: /* declarator  */
#line 155 "src/parse.y"
            { free_declarator(((*yyvaluep).declarator)); }
#line 1645 "src/parse.c"
        break;

    case YYSYMBOL_declarator_ish: /* declarator_ish  */
#line 155 "src/parse.y"
            { free_declarator(((*yyvaluep).declarator)); }
#line 1651 "src/parse.c"
        break;

    case YYSYMBOL_postfix: /* postfix  */
#line 155 "src/parse.y"
            { free_declarator(((*yyvaluep).declarator)); }
#line 1657 "src/parse.c"
        break;

    case YYSYMBOL_direct_declarator_ish: /* direct_declarator_ish  */
#line 155 "src/parse.y"
            { free_declarator(((*yyvaluep).declarator)); }
#line 1663 "src/parse.c"
        break;

    case YYSYMBOL_direct_declarator: /* direct_declarator  */
#line 155 "src/parse.y"
            { free_declarator(((*yyvaluep).declarator)); }
#line 1669 "src/parse.c"
        break;

    case YYSYMBOL_english: /* english  */
#line 156 "src/parse.y"
            { free_decl(((*yyvaluep).decl)); }
#line 1675 "src/parse.c"
        break;

    case YYSYMBOL_storage_func_specs: /* storage_func_specs  */
#line 154 "src/parse.y"
            { free_declspec(((*yyvaluep).declspec)); }
#line 1681 "src/parse.c"
        break;

    case YYSYMBOL_type_qual_spec: /* type_qual_spec  */
#line 154 "src/parse.y"
            { free_declspec(((*yyvaluep).declspec)); }
#line 1687 "src/parse.c"
        break;

    case YYSYMBOL_type_qual_specs: /* type_qual_specs  */
#line 154 "src/parse.y"
            { free_declspec(((*yyvaluep).declspec)); }
#line 1693 "src/parse.c"
        break;

    case YYSYMBOL_post_specs: /* post_specs  */
#line 154 "src/parse.y"
            { free_declspec(((*yyvaluep).declspec)); }
#line 1699 "src/parse.c"
        break;

    case YYSYMBOL_english_declaration: /* english_declaration  */
#line 156 "src/parse.y"
            { free_decl(((*yyvaluep).decl)); }
#line 1705 "src/parse.c"
        break;

    case YYSYMBOL_english_declarator: /* english_declarator  */
#line 155 "src/parse.y"
            { free_declarator(((*yyvaluep).declarator)); }
#line 1711 "src/parse.c"
        break;

    case YYSYMBOL_english_function: /* english_function  */
#line 155 "src/parse.y"
            { free_declarator(((*yyvaluep).declarator)); }
#line 1717 "src/parse.c"
        break;

    case YYSYMBOL_english_parameter_list: /* english_parameter_list  */
#line 155 "src/parse.y"
            { free_declarator(((*yyvaluep).declarator)); }
#line 1723 "src/parse.c"
        break;

    case YYSYMBOL_english_parameters: /* english_parameters  */
#line 156 "src/parse.y"
            { free_decl(((*yyvaluep).decl)); }
#line 1729 "src/parse.c"
        break;

    case YYSYMBOL_typedef_name_qual: /* typedef_name_qual  */
#line 154 "src/parse.y"
            { free_declspec(((*yyvaluep).declspec)); }
#line 1735 "src/parse.c"
        break;

    case YYSYMBOL_null_decl: /* null_decl  */
#line 155 "src/parse.y"
            { free_declarator(((*yyvaluep).declarator)); }
#line 1741 "src/parse.c"
        break;

    case YYSYMBOL_english_parameter: /* english_parameter  */
#line 156 "src/parse.y"
            { free_decl(((*yyvaluep).decl)); }
#line 1747 "src/parse.c"
        break;

    case YYSYMBOL_english_array: /* english_array  */
#line 155 "src/parse.y"
            { free_declarator(((*yyvaluep).declarator)); }
#line 1753 "src/parse.c"
        break;

    case YYSYMBOL_english_vla: /* english_vla  */
#line 153 "src/parse.y"
            { free(((*yyvaluep).strval)); }
#line 1759 "src/parse.c"
        break;

      default:
        break;
    }
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}






/*----------.
| yyparse.  |
`----------*/

int
yyparse (void *scanner, struct cdecl **out)
{
/* Lookahead token kind.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

/* Location data for the lookahead symbol.  */
static YYLTYPE yyloc_default
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
YYLTYPE yylloc = yyloc_default;

    /* Number of syntax errors so far.  */
    int yynerrs = 0;

    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

    /* The location stack: array, bottom, top.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls = yylsa;
    YYLTYPE *yylsp = yyls;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

  /* The locations where the error started and ended.  */
  YYLTYPE yyerror_range[3];

  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  yylsp[0] = yylloc;
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yyls1, yysize * YYSIZEOF (*yylsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
        yyls = yyls1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex (&yylval, &yylloc, scanner);
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      yyerror_range[1] = yylloc;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location. */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  yyerror_range[1] = yyloc;
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* input: T_ENGLISH english  */
#line 244 "src/parse.y"
                         {
	*out = (yyvsp[0].decl);
}
#line 2067 "src/parse.c"
    break;

  case 3: /* input: declaration  */
#line 246 "src/parse.y"
                {
	*out = (yyvsp[0].decl);
}
#line 2075 "src/parse.c"
    break;

  case 6: /* declaration: declspecs declarators semi  */
#line 252 "src/parse.y"
                                        {
	(yyval.decl) = (yyvsp[-1].decl);

	for (struct cdecl *i = (yyval.decl); i; i = i->next)
		i->specifiers = (yyvsp[-2].declspec);
}
#line 2086 "src/parse.c"
    break;

  case 7: /* declspecs: declspec_notype declspecs  */
#line 259 "src/parse.y"
                                     {
	(yyval.declspec) = (yyvsp[-1].declspec);
	(yyval.declspec)->next = (yyvsp[0].declspec);
}
#line 2095 "src/parse.c"
    break;

  case 8: /* declspecs: typespec declspecs_noid  */
#line 262 "src/parse.y"
                            {
	(yyval.declspec) = (yyvsp[-1].declspec);
	(yyval.declspec)->next = (yyvsp[0].declspec);
}
#line 2104 "src/parse.c"
    break;

  case 9: /* declspecs_noid: %empty  */
#line 267 "src/parse.y"
                { (yyval.declspec) = NULL; }
#line 2110 "src/parse.c"
    break;

  case 10: /* declspecs_noid: declspec_noid declspecs_noid  */
#line 267 "src/parse.y"
                                                              {
	(yyval.declspec) = (yyvsp[-1].declspec);
	(yyval.declspec)->next = (yyvsp[0].declspec);
}
#line 2119 "src/parse.c"
    break;

  case 11: /* qualifiers: %empty  */
#line 272 "src/parse.y"
            { (yyval.declspec) = NULL; }
#line 2125 "src/parse.c"
    break;

  case 12: /* qualifiers: qualifiers qualifier  */
#line 272 "src/parse.y"
                                                  {
	(yyval.declspec) = (yyvsp[0].declspec);
	(yyval.declspec)->next = (yyvsp[-1].declspec);
}
#line 2134 "src/parse.c"
    break;

  case 14: /* declarators: declarator_wrap "," declarators  */
#line 277 "src/parse.y"
                                                                   {
	(yyval.decl) = (yyvsp[-2].decl);
	(yyval.decl)->next = (yyvsp[0].decl);
}
#line 2143 "src/parse.c"
    break;

  case 15: /* declarator_wrap: declarator  */
#line 282 "src/parse.y"
                            {
	ALLOC_STRUCT((yyval.decl), struct cdecl, .declarators = (yyvsp[0].declarator));
}
#line 2151 "src/parse.c"
    break;

  case 16: /* declspec_simple: "auto"  */
#line 286 "src/parse.y"
                        { (yyval.spectype) = CDECL_STOR_AUTO;     }
#line 2157 "src/parse.c"
    break;

  case 17: /* declspec_simple: "typedef"  */
#line 287 "src/parse.y"
                        { (yyval.spectype) = CDECL_STOR_TYPEDEF;  }
#line 2163 "src/parse.c"
    break;

  case 18: /* declspec_simple: "extern"  */
#line 288 "src/parse.y"
                        { (yyval.spectype) = CDECL_STOR_EXTERN;   }
#line 2169 "src/parse.c"
    break;

  case 19: /* declspec_simple: "static"  */
#line 289 "src/parse.y"
                        { (yyval.spectype) = CDECL_STOR_STATIC;   }
#line 2175 "src/parse.c"
    break;

  case 20: /* declspec_simple: "register"  */
#line 290 "src/parse.y"
                        { (yyval.spectype) = CDECL_STOR_REGISTER; }
#line 2181 "src/parse.c"
    break;

  case 21: /* declspec_simple: "inline"  */
#line 291 "src/parse.y"
                        { (yyval.spectype) = CDECL_FUNC_INLINE;   }
#line 2187 "src/parse.c"
    break;

  case 22: /* typespec_simple: "void"  */
#line 293 "src/parse.y"
                        { (yyval.spectype) = CDECL_TYPE_VOID;      }
#line 2193 "src/parse.c"
    break;

  case 23: /* typespec_simple: "char"  */
#line 294 "src/parse.y"
                        { (yyval.spectype) = CDECL_TYPE_CHAR;      }
#line 2199 "src/parse.c"
    break;

  case 24: /* typespec_simple: "short"  */
#line 295 "src/parse.y"
                        { (yyval.spectype) = CDECL_TYPE_SHORT;     }
#line 2205 "src/parse.c"
    break;

  case 25: /* typespec_simple: "int"  */
#line 296 "src/parse.y"
                        { (yyval.spectype) = CDECL_TYPE_INT;       }
#line 2211 "src/parse.c"
    break;

  case 26: /* typespec_simple: "long"  */
#line 297 "src/parse.y"
                        { (yyval.spectype) = CDECL_TYPE_LONG;      }
#line 2217 "src/parse.c"
    break;

  case 27: /* typespec_simple: "float"  */
#line 298 "src/parse.y"
                        { (yyval.spectype) = CDECL_TYPE_FLOAT;     }
#line 2223 "src/parse.c"
    break;

  case 28: /* typespec_simple: "double"  */
#line 299 "src/parse.y"
                        { (yyval.spectype) = CDECL_TYPE_DOUBLE;    }
#line 2229 "src/parse.c"
    break;

  case 29: /* typespec_simple: "signed"  */
#line 300 "src/parse.y"
                        { (yyval.spectype) = CDECL_TYPE_SIGNED;    }
#line 2235 "src/parse.c"
    break;

  case 30: /* typespec_simple: "unsigned"  */
#line 301 "src/parse.y"
                        { (yyval.spectype) = CDECL_TYPE_UNSIGNED;  }
#line 2241 "src/parse.c"
    break;

  case 31: /* typespec_simple: "_Bool"  */
#line 302 "src/parse.y"
                        { (yyval.spectype) = CDECL_TYPE_BOOL;      }
#line 2247 "src/parse.c"
    break;

  case 32: /* typespec_simple: "_Complex"  */
#line 303 "src/parse.y"
                        { (yyval.spectype) = CDECL_TYPE_COMPLEX;   }
#line 2253 "src/parse.c"
    break;

  case 33: /* typespec_simple: "_Imaginary"  */
#line 304 "src/parse.y"
                        { (yyval.spectype) = CDECL_TYPE_IMAGINARY; }
#line 2259 "src/parse.c"
    break;

  case 34: /* qualifier_simple: "const"  */
#line 306 "src/parse.y"
                          { (yyval.spectype) = CDECL_QUAL_CONST;    }
#line 2265 "src/parse.c"
    break;

  case 35: /* qualifier_simple: "restrict"  */
#line 307 "src/parse.y"
                          { (yyval.spectype) = CDECL_QUAL_RESTRICT; }
#line 2271 "src/parse.c"
    break;

  case 36: /* qualifier_simple: "volatile"  */
#line 308 "src/parse.y"
                          { (yyval.spectype) = CDECL_QUAL_VOLATILE; }
#line 2277 "src/parse.c"
    break;

  case 38: /* declspec_notype: declspec_simple  */
#line 310 "src/parse.y"
                                             {
	ALLOC_STRUCT((yyval.declspec), struct cdecl_declspec, .type = (yyvsp[0].spectype));
}
#line 2285 "src/parse.c"
    break;

  case 39: /* typespec_noid: typespec_simple  */
#line 314 "src/parse.y"
                               {
	ALLOC_STRUCT((yyval.declspec), struct cdecl_declspec, .type = (yyvsp[0].spectype));
}
#line 2293 "src/parse.c"
    break;

  case 40: /* qualifier: qualifier_simple  */
#line 318 "src/parse.y"
                            {
	ALLOC_STRUCT((yyval.declspec), struct cdecl_declspec, .type = (yyvsp[0].spectype));
}
#line 2301 "src/parse.c"
    break;

  case 42: /* typespec: "struct" "identifier"  */
#line 322 "src/parse.y"
                                           {
	ALLOC_STRUCT((yyval.declspec), struct cdecl_declspec,
		.type = CDECL_TYPE_STRUCT,
		.ident = (yyvsp[0].strval));
}
#line 2311 "src/parse.c"
    break;

  case 43: /* typespec: "union" "identifier"  */
#line 326 "src/parse.y"
                    {
	ALLOC_STRUCT((yyval.declspec), struct cdecl_declspec,
		.type = CDECL_TYPE_UNION,
		.ident = (yyvsp[0].strval));
}
#line 2321 "src/parse.c"
    break;

  case 44: /* typespec: "enum" "identifier"  */
#line 330 "src/parse.y"
                   {
	ALLOC_STRUCT((yyval.declspec), struct cdecl_declspec,
		.type = CDECL_TYPE_ENUM,
		.ident = (yyvsp[0].strval));
}
#line 2331 "src/parse.c"
    break;

  case 45: /* typespec: "identifier"  */
#line 334 "src/parse.y"
            {
	ALLOC_STRUCT((yyval.declspec), struct cdecl_declspec,
		.type = CDECL_TYPE_IDENT,
		.ident = (yyvsp[0].strval));
}
#line 2341 "src/parse.c"
    break;

  case 49: /* vla_ident: "*"  */
#line 342 "src/parse.y"
                                {
	ALLOC((yyval.strval), sizeof "");
	strcpy((yyval.strval), "");
}
#line 2350 "src/parse.c"
    break;

  case 50: /* array: "[" "integer constant" "]"  */
#line 347 "src/parse.y"
                                    {
	if ((yyvsp[-1].uintval) == 0)
		FAIL(_("array length must be positive"));

	ALLOC_STRUCT((yyval.declarator), struct cdecl_declarator,
		.type = CDECL_DECL_ARRAY,
		.u.array.length = (yyvsp[-1].uintval));
}
#line 2363 "src/parse.c"
    break;

  case 51: /* array: "[" vla_ident "]"  */
#line 354 "src/parse.y"
                                    {
	ALLOC_STRUCT((yyval.declarator), struct cdecl_declarator,
		.type = CDECL_DECL_ARRAY,
		.u.array.vla = (yyvsp[-1].strval));
}
#line 2373 "src/parse.c"
    break;

  case 52: /* array: "[" "]"  */
#line 358 "src/parse.y"
                          {
	ALLOC_STRUCT((yyval.declarator), struct cdecl_declarator,
		.type = CDECL_DECL_ARRAY);
}
#line 2382 "src/parse.c"
    break;

  case 53: /* parameter: declspecs declarator  */
#line 363 "src/parse.y"
                                {
	ALLOC_STRUCT((yyval.decl), struct cdecl,
		.specifiers = (yyvsp[-1].declspec),
		.declarators = (yyvsp[0].declarator));
}
#line 2392 "src/parse.c"
    break;

  case 55: /* parameters: parameters "," parameter  */
#line 369 "src/parse.y"
                                                     {
	(yyval.decl) = (yyvsp[0].decl);
	(yyval.decl)->next = (yyvsp[-2].decl);
}
#line 2401 "src/parse.c"
    break;

  case 56: /* varargs: %empty  */
#line 374 "src/parse.y"
         { (yyval.boolval) = false; }
#line 2407 "src/parse.c"
    break;

  case 57: /* varargs: "," "..."  */
#line 374 "src/parse.y"
                                              { (yyval.boolval) = true; }
#line 2413 "src/parse.c"
    break;

  case 58: /* parameter_type_list: parameters varargs  */
#line 376 "src/parse.y"
                                        {
	struct cdecl *p, *c, *n;

	/* Parameters were accumulated in reverse order. */
	for (p = NULL, c = (yyvsp[-1].decl); c; p = c, c = n) {
		n = c->next;
		c->next = p;
	}

	ALLOC_STRUCT((yyval.declarator), struct cdecl_declarator,
		.type = CDECL_DECL_FUNCTION,
		.u.function.parameters = p,
		.u.function.variadic = (yyvsp[0].boolval));
}
#line 2432 "src/parse.c"
    break;

  case 59: /* parens: "(" parameter_type_list ")"  */
#line 391 "src/parse.y"
                                              {
	(yyval.declarator) = (yyvsp[-1].declarator);
}
#line 2440 "src/parse.c"
    break;

  case 60: /* parens: "(" declarator_ish ")"  */
#line 393 "src/parse.y"
                                     {
	ALLOC_STRUCT((yyval.declarator), struct cdecl_declarator,
		.type = CDECL_DECL_FUNCTION);
	ALLOC_STRUCT((yyval.declarator)->u.function.parameters, struct cdecl,
		.declarators = (yyvsp[-1].declarator));
}
#line 2451 "src/parse.c"
    break;

  case 61: /* pointer: "*" qualifiers direct_declarator  */
#line 400 "src/parse.y"
                                                 {
	ALLOC_STRUCT((yyval.declarator), struct cdecl_declarator,
		.type = CDECL_DECL_POINTER,
		.u.pointer.qualifiers = (yyvsp[-1].declspec),
		.child = (yyvsp[0].declarator));
}
#line 2462 "src/parse.c"
    break;

  case 62: /* pointer: "*" qualifiers pointer  */
#line 405 "src/parse.y"
                                  {
	ALLOC_STRUCT((yyval.declarator), struct cdecl_declarator,
		.type = CDECL_DECL_POINTER,
		.u.pointer.qualifiers = (yyvsp[-1].declspec),
		.child = (yyvsp[0].declarator));
}
#line 2473 "src/parse.c"
    break;

  case 69: /* direct_declarator_ish: %empty  */
#line 416 "src/parse.y"
                       {
	ALLOC_STRUCT((yyval.declarator), struct cdecl_declarator,
		.type = CDECL_DECL_NULL);
}
#line 2482 "src/parse.c"
    break;

  case 70: /* direct_declarator_ish: direct_declarator_ish postfix  */
#line 419 "src/parse.y"
                                  {
	(yyval.declarator) = (yyvsp[0].declarator);
	(yyval.declarator)->child = (yyvsp[-1].declarator);
}
#line 2491 "src/parse.c"
    break;

  case 71: /* direct_declarator: %empty  */
#line 424 "src/parse.y"
                   {
	ALLOC_STRUCT((yyval.declarator), struct cdecl_declarator,
		.type = CDECL_DECL_NULL);
}
#line 2500 "src/parse.c"
    break;

  case 72: /* direct_declarator: "identifier"  */
#line 427 "src/parse.y"
            {
	ALLOC_STRUCT((yyval.declarator), struct cdecl_declarator,
		.type = CDECL_DECL_IDENT,
		.u.ident = (yyvsp[0].strval));
}
#line 2510 "src/parse.c"
    break;

  case 73: /* direct_declarator: direct_declarator postfix  */
#line 431 "src/parse.y"
                              {
	(yyval.declarator) = (yyvsp[0].declarator);
	(yyval.declarator)->child = (yyvsp[-1].declarator);
}
#line 2519 "src/parse.c"
    break;

  case 74: /* english: "declare" "identifier" "as" english_declaration  */
#line 436 "src/parse.y"
                                                    {
	(yyval.decl) = (yyvsp[0].decl);
	for (struct cdecl_declarator *d = (yyval.decl)->declarators; d; d = d->child) {
		if (d->type == CDECL_DECL_NULL) {
			d->type = CDECL_DECL_IDENT;
			d->u.ident = (yyvsp[-2].strval);
		}
	}
}
#line 2533 "src/parse.c"
    break;

  case 75: /* english: "type" english_declaration  */
#line 444 "src/parse.y"
                               {
	(yyval.decl) = (yyvsp[0].decl);
}
#line 2541 "src/parse.c"
    break;

  case 76: /* storage_func_specs: %empty  */
#line 448 "src/parse.y"
                    { (yyval.declspec) = NULL; }
#line 2547 "src/parse.c"
    break;

  case 77: /* storage_func_specs: declspec_simple storage_func_specs  */
#line 448 "src/parse.y"
                                                                        {
	ALLOC_STRUCT((yyval.declspec), struct cdecl_declspec,
		.type = (yyvsp[-1].spectype),
		.next = (yyvsp[0].declspec));
}
#line 2557 "src/parse.c"
    break;

  case 80: /* type_qual_specs: %empty  */
#line 456 "src/parse.y"
                 { (yyval.declspec) = NULL; }
#line 2563 "src/parse.c"
    break;

  case 81: /* type_qual_specs: type_qual_spec type_qual_specs  */
#line 456 "src/parse.y"
                                                                 {
	(yyval.declspec) = (yyvsp[-1].declspec);
	(yyval.declspec)->next = (yyvsp[0].declspec);
}
#line 2572 "src/parse.c"
    break;

  case 82: /* post_specs: qualifiers typespec type_qual_specs  */
#line 466 "src/parse.y"
                                                {
	(yyval.declspec) = (yyvsp[-1].declspec);
	(yyval.declspec)->next = (yyvsp[-2].declspec);
	for (struct cdecl_declspec *s = (yyval.declspec); s; s = s->next) {
		if (!s->next) {
			s->next = (yyvsp[0].declspec);
			break;
		}
	}
}
#line 2587 "src/parse.c"
    break;

  case 83: /* english_declaration: storage_func_specs english_declarator post_specs  */
#line 477 "src/parse.y"
                                                                      {
	ALLOC_STRUCT((yyval.decl), struct cdecl,
		.specifiers = (yyvsp[0].declspec),
		.declarators = (yyvsp[-1].declarator));

	for (struct cdecl_declspec *s = (yyval.decl)->specifiers; s; s = s->next) {
		if (!s->next) {
			s->next = (yyvsp[-2].declspec);
			break;
		}
	}
}
#line 2604 "src/parse.c"
    break;

  case 84: /* english_declarator: %empty  */
#line 490 "src/parse.y"
                    {
	ALLOC_STRUCT((yyval.declarator), struct cdecl_declarator,
		.type = CDECL_DECL_NULL);
}
#line 2613 "src/parse.c"
    break;

  case 85: /* english_declarator: english_declarator qualifiers "pointer" "to"  */
#line 493 "src/parse.y"
                                                 {
	ALLOC_STRUCT((yyval.declarator), struct cdecl_declarator,
		.type = CDECL_DECL_POINTER,
		.child = (yyvsp[-3].declarator),
		.u.pointer.qualifiers = (yyvsp[-2].declspec));
}
#line 2624 "src/parse.c"
    break;

  case 86: /* english_declarator: english_declarator english_array  */
#line 498 "src/parse.y"
                                     {
	(yyval.declarator) = (yyvsp[0].declarator);
	(yyval.declarator)->child = (yyvsp[-1].declarator);
}
#line 2633 "src/parse.c"
    break;

  case 87: /* english_declarator: english_declarator english_function  */
#line 501 "src/parse.y"
                                        {
	(yyval.declarator) = (yyvsp[0].declarator);
	(yyval.declarator)->child = (yyvsp[-1].declarator);
}
#line 2642 "src/parse.c"
    break;

  case 88: /* english_function: "function" "returning"  */
#line 506 "src/parse.y"
                                         {
	ALLOC_STRUCT((yyval.declarator), struct cdecl_declarator,
		.type = CDECL_DECL_FUNCTION,
		.u.function.parameters = NULL);
}
#line 2652 "src/parse.c"
    break;

  case 89: /* english_function: "function" "(" english_parameter_list ")" "returning"  */
#line 510 "src/parse.y"
                                                                    {
	(yyval.declarator) = (yyvsp[-2].declarator);
}
#line 2660 "src/parse.c"
    break;

  case 90: /* english_parameter_list: english_parameters varargs  */
#line 514 "src/parse.y"
                                                   {
	struct cdecl *p, *c, *n;

	/* Parameters were accumulated in reverse order. */
	for (p = NULL, c = (yyvsp[-1].decl); c; p = c, c = n) {
		n = c->next;
		c->next = p;
	}

	ALLOC_STRUCT((yyval.declarator), struct cdecl_declarator,
		.type = CDECL_DECL_FUNCTION,
		.u.function.parameters = p,
		.u.function.variadic = (yyvsp[0].boolval));
}
#line 2679 "src/parse.c"
    break;

  case 91: /* english_parameters: english_parameters "," english_parameter  */
#line 529 "src/parse.y"
                                                                 {
	(yyval.decl) = (yyvsp[0].decl);
	(yyval.decl)->next = (yyvsp[-2].decl);
}
#line 2688 "src/parse.c"
    break;

  case 93: /* typedef_name_qual: "identifier" qualifiers  */
#line 534 "src/parse.y"
                                      {
	ALLOC_STRUCT((yyval.declspec), struct cdecl_declspec,
		.type = CDECL_TYPE_IDENT,
		.ident = (yyvsp[-1].strval),
		.next = (yyvsp[0].declspec));
}
#line 2699 "src/parse.c"
    break;

  case 94: /* null_decl: %empty  */
#line 541 "src/parse.y"
           {
	ALLOC_STRUCT((yyval.declarator), struct cdecl_declarator,
		.type = CDECL_DECL_NULL);
}
#line 2708 "src/parse.c"
    break;

  case 96: /* english_parameter: typedef_name_qual null_decl  */
#line 556 "src/parse.y"
                                                                     {
	ALLOC_STRUCT((yyval.decl), struct cdecl,
		.specifiers = (yyvsp[-1].declspec),
		.declarators = (yyvsp[0].declarator));
}
#line 2718 "src/parse.c"
    break;

  case 97: /* english_parameter: "identifier" "as" english_declaration  */
#line 560 "src/parse.y"
                                     {
	(yyval.decl) = (yyvsp[0].decl);
	for (struct cdecl_declarator *d = (yyval.decl)->declarators; d; d = d->child) {
		if (d->type == CDECL_DECL_NULL) {
			d->type = CDECL_DECL_IDENT;
			d->u.ident = (yyvsp[-2].strval);
		}
	}
}
#line 2732 "src/parse.c"
    break;

  case 98: /* english_array: "variable-length" "array" english_vla "of"  */
#line 570 "src/parse.y"
                                              {
	ALLOC_STRUCT((yyval.declarator), struct cdecl_declarator,
		.type = CDECL_DECL_ARRAY,
		.u.array.vla = (yyvsp[-1].strval));
}
#line 2742 "src/parse.c"
    break;

  case 99: /* english_array: "array" "integer constant" "of"  */
#line 574 "src/parse.y"
                        {
	if ((yyvsp[-1].uintval) == 0)
		FAIL(_("array length must be positive"));

	ALLOC_STRUCT((yyval.declarator), struct cdecl_declarator,
		.type = CDECL_DECL_ARRAY,
		.u.array.length = (yyvsp[-1].uintval));
}
#line 2755 "src/parse.c"
    break;

  case 100: /* english_array: "array" "of"  */
#line 581 "src/parse.y"
                 {
	ALLOC_STRUCT((yyval.declarator), struct cdecl_declarator,
		.type = CDECL_DECL_ARRAY,
		.u.array.length = 0);
}
#line 2765 "src/parse.c"
    break;

  case 102: /* english_vla: %empty  */
#line 587 "src/parse.y"
                       {
	ALLOC((yyval.strval), sizeof "");
	strcpy((yyval.strval), "");
}
#line 2774 "src/parse.c"
    break;


#line 2778 "src/parse.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      {
        yypcontext_t yyctx
          = {yyssp, yytoken, &yylloc};
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == -1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *,
                             YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (yymsg)
              {
                yysyntax_error_status
                  = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
                yymsgp = yymsg;
              }
            else
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = YYENOMEM;
              }
          }
        yyerror (&yylloc, scanner, out, yymsgp);
        if (yysyntax_error_status == YYENOMEM)
          YYNOMEM;
      }
    }

  yyerror_range[1] = yylloc;
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc, scanner, out);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, yylsp, scanner, out);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  ++yylsp;
  YYLLOC_DEFAULT (*yylsp, yyerror_range, 2);

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (&yylloc, scanner, out, YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc, scanner, out);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, yylsp, scanner, out);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
  return yyresult;
}

